/*
 * $Id: OptionalParamsTestCase.java 19026 2010-08-16 07:30:47Z dirk.olmes $
 * -------------------------------------------------------------------------------------
 * Copyright (c) MuleSoft, Inc.  All rights reserved.  http://www.mulesoft.com
 *
 * The software in this package is published under the terms of the CPAL v1.0
 * license, a copy of which has been included with this distribution in the
 * LICENSE.txt file.
 */
package org.mule.module.ibeans.annotations;

import java.net.UnknownHostException;

import org.ibeans.annotation.IntegrationBean;
import org.junit.Test;

public class OptionalParamsTestCase extends AbstractIBeansTestCase
{
    @SuppressWarnings("unused")
    @IntegrationBean
    private TestUriIBean test;

    @Test
    public void testOptionalParams() throws Exception
    {
        String result = test.doSomethingOptional("x", "y");
        assertEquals("http://doesnotexist.bom?param1=x&param2=y", result);

        result = test.doSomethingOptional("x", null);
        assertEquals("http://doesnotexist.bom?param1=x", result);

        result = test.doSomethingOptional(null, "y");
        assertEquals("http://doesnotexist.bom?param2=y", result);
    }

    @Test(expected = IllegalArgumentException.class)
    public void paramNull() throws UnknownHostException
    {
        try
        {
            test.doSomethingElse("x", null);
            fail("Null argument is not optional");
        }
        catch (IllegalArgumentException e)
        {
            //expected
        }
    }
}
